Description

The attached patch adds a new operator "contains any of" for string/text filters and "Any searchable text" filter introduced by #38402.

With this new operator, you can perform an OR search with multiple terms specified in single filter.

For example, if you choose the "Subject" filter and specify the "contains any of" operator and give "close block" as the value, issues

containing either "close" or "block" in the subject will be displayed.

I believe this new OR search support in addition to the AND search added in Redmine 5.0 (#35764) will make Redmine's query

system even more powerful.

 clipboard-202304121202-2fiuq.png 

Related issues:

Related to Redmine - Feature #38446: Support multiple multi-word phrases in t... Closed

Associated revisions

Revision 22188 - 2023-04-15 01:50 - Go MAEDA

"contains any of" operator for text filters to perform OR search of multiple terms (#38435).

Patch by Go MAEDA.

Revision 22189 - 2023-04-15 02:00 - Go MAEDA

Update locales (#38435).

Revision 22190 - 2023-04-15 02:52 - Go MAEDA

Increase max-width of operator select in filters (#38435).

Revision 22195 - 2023-04-16 07:46 - Go MAEDA

Fix "contains any of" operator is not taken into account in File and File description filters (#38435).

Revision 22197 - 2023-04-16 10:02 - Go MAEDA

Change the notation of "contains any of" filter operator to "*~" (#38435).

Revision 22198 - 2023-04-16 10:31 - Go MAEDA

Revert the change made in error in r22197 (#38435).

History

#1 - 2023-04-13 08:29 - Robert Korulczyk

I think there should be a way to search also by multiple multi-word phrases. For example issues with "closed issue" or "closed version".

#2 - 2023-04-13 09:32 - Go MAEDA

Robert Korulczyk wrote in #note-1:

I think there should be a way to search also by multiple multi-word phrases. For example issues with "closed issue" or "closed version".

 Thank you for your comment. Due to the behavior of Redmine::Search::Tokenizer#tokens, the new filter does not support multiple quoted strings. This

is the same with the search box in the upper right corner and the existing "contains" filter.
Redmine::Search::Tokenizer.new(%q|"closed issue" "closed version"|).tokens

=> ["closed issue", "closed", "version"]

 I agree with improving Redmine::Search::Tokenizer#token to support multiple quoted strings, I think this should be discussed independently of this

new "contains any of" filter. I have just opened #38446 for this improvement.

#3 - 2023-04-14 03:10 - Go MAEDA

- Target version set to 5.1.0

Setting the target version to 5.1.0.

#4 - 2023-04-15 01:51 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch.

#5 - 2024-06-20 03:03 - Go MAEDA

- Related to Feature #38446: Support multiple multi-word phrases in the search engine added
